diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 9b58790f694..e4ca20e06be 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -706,14 +706,11 @@ void output_module( DLLSPEC *spec )
     output( "\t.long 0\n" );              /* SizeOfCode */
     output( "\t.long 0\n" );              /* SizeOfInitializedData */
     output( "\t.long 0\n" );              /* SizeOfUninitializedData */
-    /* note: we expand the AddressOfEntryPoint field on 64-bit by overwriting the BaseOfCode field */
-    output( "\t%s %s\n",                  /* AddressOfEntryPoint */
-            get_asm_ptr_keyword(), spec->init_func ? asm_name(spec->init_func) : "0" );
+    output_rva( spec->init_func ?         /* AddressOfEntryPoint */
+                asm_name(spec->init_func) : "0" );
+    output( "\t.long 0\n" );              /* BaseOfCode */
     if (get_ptr_size() == 4)
-    {
-        output( "\t.long 0\n" );          /* BaseOfCode */
         output( "\t.long 0\n" );          /* BaseOfData */
-    }
     output( "\t%s .L__wine_spec_dos\n",   /* ImageBase */
              get_asm_ptr_keyword() );
     output( "\t.long %u\n", page_size );  /* SectionAlignment */
-- 
2.27.0

>From 63a77654e3066554b519f154411891c9d5d1028e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 11 Jun 2020 21:35:55 +0200
Subject: [PATCH 10/32] winebuild: Output .data section header.

The .data section will be kept last and the .text section will be first,
so that we can add PE sections in the middle and keep track of the
code_start / code_end, until we can get the linker generate it for us.
---
 dlls/ntdll/unix/loader.c | 38 ++++++--------------------------------
 tools/winebuild/build.h  |  1 +
 tools/winebuild/spec32.c | 39 ++++++++++++++++++++++++++++++++++++---
 tools/winebuild/utils.c  | 10 ++++++++++
 4 files changed, 53 insertions(+), 35 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index ab2dab833e6..86b149e036a 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -755,7 +755,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     IMAGE_NT_HEADERS *nt;
     IMAGE_SECTION_HEADER *sec;
     BYTE *addr = (BYTE *)module;
-    DWORD code_start, code_end, data_start, data_end, align_mask;
+    DWORD code_start, code_end, align_mask;
     int delta;
     unsigned int i;
     DWORD size = nt_descr->OptionalHeader.SizeOfHeaders;
@@ -772,10 +772,14 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     /* fixup the sections */
 
+    fixup_rva_dwords( &nt->OptionalHeader.SizeOfImage, delta, 1 );
+    code_end = nt->OptionalHeader.SizeOfImage;
+
     for (i = 0; i < nt->FileHeader.NumberOfSections; ++i)
     {
         fixup_rva_dwords( &sec[i].VirtualAddress, delta, 1 );
         fixup_rva_dwords( &sec[i].PointerToRawData, delta, 1 );
+        if (code_end > sec[i].VirtualAddress) code_end = sec[i].VirtualAddress;
 
         if ((sec[i].Characteristics & IMAGE_SCN_CNT_INITIALIZED_DATA) &&
             remap_writable( addr + sec[i].VirtualAddress, sec[i].Misc.VirtualSize ))
@@ -789,31 +793,13 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     align_mask = nt->OptionalHeader.SectionAlignment - 1;
     code_start = (size + align_mask) & ~align_mask;
-    data_start = delta & ~align_mask;
-#ifdef __APPLE__
-    {
-        Dl_info dli;
-        unsigned long data_size;
-        /* need the mach_header, not the PE header, to give to getsegmentdata(3) */
-        dladdr(addr, &dli);
-        code_end   = getsegmentdata(dli.dli_fbase, "__DATA", &data_size) - addr;
-        data_end   = (code_end + data_size + align_mask) & ~align_mask;
-    }
-#else
-    code_end   = data_start;
-    data_end   = (nt->OptionalHeader.SizeOfImage + delta + align_mask) & ~align_mask;
-#endif
-
     fixup_rva_dwords( &nt->OptionalHeader.AddressOfEntryPoint, delta, 1 );
 
     nt->OptionalHeader.BaseOfCode                  = code_start;
 #ifndef _WIN64
-    nt->OptionalHeader.BaseOfData                  = data_start;
+    fixup_rva_dwords( &nt->OptionalHeader.BaseOfData, delta, 1 );
 #endif
     nt->OptionalHeader.SizeOfCode                  = code_end - code_start;
-    nt->OptionalHeader.SizeOfInitializedData       = data_end - data_start;
-    nt->OptionalHeader.SizeOfUninitializedData     = 0;
-    nt->OptionalHeader.SizeOfImage                 = data_end;
 
     /* build the code section */
 
@@ -826,18 +812,6 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     nt->FileHeader.NumberOfSections++;
     sec++;
 
-    /* build the data section */
-
-    memcpy( sec->Name, ".data", sizeof(".data") );
-    sec->SizeOfRawData = data_end - data_start;
-    sec->Misc.VirtualSize = sec->SizeOfRawData;
-    sec->VirtualAddress   = data_start;
-    sec->PointerToRawData = data_start;
-    sec->Characteristics  = (IMAGE_SCN_CNT_INITIALIZED_DATA |
-                             IMAGE_SCN_MEM_WRITE | IMAGE_SCN_MEM_READ);
-    nt->FileHeader.NumberOfSections++;
-    sec++;
-
     for (i = 0; i < nt->OptionalHeader.NumberOfRvaAndSizes; i++)
         fixup_rva_dwords( &nt->OptionalHeader.DataDirectory[i].VirtualAddress, delta, 1 );
 
diff --git a/tools/winebuild/build.h b/tools/winebuild/build.h
index c162888a035..c3a8756e010 100644
--- a/tools/winebuild/build.h
+++ b/tools/winebuild/build.h
@@ -285,6 +285,7 @@ extern const char *func_declaration( const char *func );
 extern const char *asm_globl( const char *func );
 extern const char *get_asm_ptr_keyword(void);
 extern const char *get_asm_string_keyword(void);
+extern const char *get_asm_data_section(void);
 extern const char *get_asm_export_section(void);
 extern const char *get_asm_rodata_section(void);
 extern const char *get_asm_rsrc_section(void);
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index e4ca20e06be..314f1ee2c62 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -141,6 +141,14 @@ static void get_arg_string( ORDDEF *odp, char str[MAX_ARGUMENTS + 1] )
         strcpy( str + i, "I" );
 }
 
+static void output_size( const char *name )
+{
+    if (!strcmp(name, ".L__wine_spec_data"))
+        output( "\t.long %s - %s\n", asm_name("_end"), name );
+    else
+        output( "\t.long %s_end - %s\n", name, name );
+}
+
 static void output_data_directories( const char *names[16] )
 {
     int i;
@@ -595,6 +603,7 @@ void output_module( DLLSPEC *spec )
     int machine = 0;
     unsigned int page_size = get_page_size();
     const char *data_dirs[16] = { NULL };
+    unsigned int nb_sections = 1;
 
     /* Reserve some space for the PE header */
 
@@ -691,7 +700,8 @@ void output_module( DLLSPEC *spec )
     }
     output( "\t.short 0x%04x\n",          /* Machine */
              machine );
-    output( "\t.short 0\n" );             /* NumberOfSections */
+    output( "\t.short 0x%04x\n",          /* NumberOfSections */
+             nb_sections );
     output( "\t.long 0\n" );              /* TimeDateStamp */
     output( "\t.long 0\n" );              /* PointerToSymbolTable */
     output( "\t.long 0\n" );              /* NumberOfSymbols */
@@ -704,13 +714,13 @@ void output_module( DLLSPEC *spec )
     output( "\t.byte 7\n" );              /* MajorLinkerVersion */
     output( "\t.byte 10\n" );             /* MinorLinkerVersion */
     output( "\t.long 0\n" );              /* SizeOfCode */
-    output( "\t.long 0\n" );              /* SizeOfInitializedData */
+    output_size( ".L__wine_spec_data" );  /* SizeOfInitializedData */
     output( "\t.long 0\n" );              /* SizeOfUninitializedData */
     output_rva( spec->init_func ?         /* AddressOfEntryPoint */
                 asm_name(spec->init_func) : "0" );
     output( "\t.long 0\n" );              /* BaseOfCode */
     if (get_ptr_size() == 4)
-        output( "\t.long 0\n" );          /* BaseOfData */
+        output_rva( ".L__wine_spec_data" ); /* BaseOfData */
     output( "\t%s .L__wine_spec_dos\n",   /* ImageBase */
              get_asm_ptr_keyword() );
     output( "\t.long %u\n", page_size );  /* SectionAlignment */
@@ -743,6 +753,20 @@ void output_module( DLLSPEC *spec )
 
     output_data_directories( data_dirs );
 
+    /* .data section */
+    output( "\t.ascii \".data\"\n" );                  /* Name */
+    output( "\t.align 8, 0\n" );
+    output_size( ".L__wine_spec_data" );               /* VirtualSize */
+    output_rva( "%s", ".L__wine_spec_data" );          /* VirtualAddress */
+    output_size( ".L__wine_spec_data" );               /* SizeOfRawData */
+    output_rva( "%s", ".L__wine_spec_data" );          /* PointerToRawData */
+    output( "\t.long 0\n" );                           /* PointerToRelocations */
+    output( "\t.long 0\n" );                           /* PointerToLinenumbers */
+    output( "\t.short 0\n" );                          /* NumberOfRelocations */
+    output( "\t.short 0\n" );                          /* NumberOfLinenumbers */
+    output( "\t.long 0xc0000040\n"                     /* Characteristics */
+            /* CNT_INITIALIZED_DATA|MEM_READ|MEM_WRITE */ );
+
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
 
@@ -758,10 +782,19 @@ void output_module( DLLSPEC *spec )
  */
 void output_spec32_file( DLLSPEC *spec )
 {
+    unsigned int page_size = get_page_size();
     needs_get_pc_thunk = 0;
     open_output_file();
     output_standard_file_header();
     output_module( spec );
+
+    if (target_platform != PLATFORM_WINDOWS)
+    {
+        output( "\t%s\n", get_asm_data_section() );
+        output( "\t.align %u, 0\n", page_size );
+        output( "\t.L__wine_spec_data:\n" );
+    }
+
     output_stubs( spec );
     output_exports( spec );
     output_imports( spec );
diff --git a/tools/winebuild/utils.c b/tools/winebuild/utils.c
index efc0637ba8a..5a102d80a1e 100644
--- a/tools/winebuild/utils.c
+++ b/tools/winebuild/utils.c
@@ -1238,6 +1238,16 @@ const char *get_asm_string_keyword(void)
     }
 }
 
+const char *get_asm_data_section(void)
+{
+    switch (target_platform)
+    {
+    case PLATFORM_APPLE:   return ".data";
+    case PLATFORM_WINDOWS: return ".section .data";
+    default:               return ".section .data";
+    }
+}
+
 const char *get_asm_export_section(void)
 {
     switch (target_platform)
-- 
2.27.0

>From f38fb184917778da543ea0c563e3261e0957a4b4 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 09:20:59 +0200
Subject: [PATCH 11/32] winebuild: Reduce .data section size.

---
 tools/winebuild/spec32.c | 18 ++++++++++--------
 1 file changed, 10 insertions(+), 8 deletions(-)

diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 314f1ee2c62..deebc9c06e8 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -143,10 +143,7 @@ static void get_arg_string( ORDDEF *odp, char str[MAX_ARGUMENTS + 1] )
 
 static void output_size( const char *name )
 {
-    if (!strcmp(name, ".L__wine_spec_data"))
-        output( "\t.long %s - %s\n", asm_name("_end"), name );
-    else
-        output( "\t.long %s_end - %s\n", name, name );
+    output( "\t.long %s_end - %s\n", name, name );
 }
 
 static void output_data_directories( const char *names[16] )
@@ -730,7 +727,7 @@ void output_module( DLLSPEC *spec )
     output( "\t.short %u,%u\n",           /* Major/MinorSubsystemVersion */
              spec->subsystem_major, spec->subsystem_minor );
     output( "\t.long 0\n" );                          /* Win32VersionValue */
-    output_rva( "%s", asm_name("_end") ); /* SizeOfImage */
+    output_rva( ".L__wine_spec_end" );    /* SizeOfImage */
     output_rva( ".L__wine_spec_pe_end" ); /* SizeOfHeaders */
     output( "\t.long 0\n" );              /* CheckSum */
     output( "\t.short 0x%04x\n",          /* Subsystem */
@@ -769,9 +766,6 @@ void output_module( DLLSPEC *spec )
 
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
-
-    if (target_platform == PLATFORM_APPLE)
-        output( "\t.lcomm %s,4\n", asm_name("_end") );
 }
 
 
@@ -800,6 +794,14 @@ void output_spec32_file( DLLSPEC *spec )
     output_imports( spec );
     if (needs_get_pc_thunk) output_get_pc_thunk();
     output_resources( spec );
+
+    if (target_platform != PLATFORM_WINDOWS)
+    {
+        output( "\t%s\n", get_asm_data_section() );
+        output( "\t.L__wine_spec_data_end:\n" );
+        output( "\t.L__wine_spec_end:\n" );
+    }
+
     output_gnu_stack_note();
     close_output_file();
 }
-- 
2.27.0

>From df7d121da45863bf0b160208a6c6229450baf598 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 09:20:59 +0200
Subject: [PATCH 12/32] winebuild: Output .text section header.

---
 dlls/ntdll/unix/loader.c | 31 ++++++++++++-------------------
 tools/winebuild/spec32.c | 22 ++++++++++++++++++++--
 2 files changed, 32 insertions(+), 21 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 86b149e036a..3a8674f94b7 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -755,7 +755,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     IMAGE_NT_HEADERS *nt;
     IMAGE_SECTION_HEADER *sec;
     BYTE *addr = (BYTE *)module;
-    DWORD code_start, code_end, align_mask;
+    DWORD code_end;
     int delta;
     unsigned int i;
     DWORD size = nt_descr->OptionalHeader.SizeOfHeaders;
@@ -779,38 +779,31 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     {
         fixup_rva_dwords( &sec[i].VirtualAddress, delta, 1 );
         fixup_rva_dwords( &sec[i].PointerToRawData, delta, 1 );
-        if (code_end > sec[i].VirtualAddress) code_end = sec[i].VirtualAddress;
+
+        if (memcmp( sec[i].Name, ".text", sizeof(".text" )) && code_end > sec[i].VirtualAddress)
+            code_end = sec[i].VirtualAddress;
 
         if ((sec[i].Characteristics & IMAGE_SCN_CNT_INITIALIZED_DATA) &&
             remap_writable( addr + sec[i].VirtualAddress, sec[i].Misc.VirtualSize ))
             return STATUS_NO_MEMORY;
     }
-    sec = sec + nt->FileHeader.NumberOfSections;
 
     /* build the NT headers */
 
     nt->OptionalHeader.ImageBase = (ULONG_PTR)addr;
 
-    align_mask = nt->OptionalHeader.SectionAlignment - 1;
-    code_start = (size + align_mask) & ~align_mask;
     fixup_rva_dwords( &nt->OptionalHeader.AddressOfEntryPoint, delta, 1 );
-
-    nt->OptionalHeader.BaseOfCode                  = code_start;
+    fixup_rva_dwords( &nt->OptionalHeader.BaseOfCode, delta, 1 );
 #ifndef _WIN64
     fixup_rva_dwords( &nt->OptionalHeader.BaseOfData, delta, 1 );
 #endif
-    nt->OptionalHeader.SizeOfCode                  = code_end - code_start;
-
-    /* build the code section */
-
-    memcpy( sec->Name, ".text", sizeof(".text") );
-    sec->SizeOfRawData = code_end - code_start;
-    sec->Misc.VirtualSize = sec->SizeOfRawData;
-    sec->VirtualAddress   = code_start;
-    sec->PointerToRawData = code_start;
-    sec->Characteristics  = (IMAGE_SCN_CNT_CODE | IMAGE_SCN_MEM_EXECUTE | IMAGE_SCN_MEM_READ);
-    nt->FileHeader.NumberOfSections++;
-    sec++;
+    nt->OptionalHeader.SizeOfCode = code_end - nt->OptionalHeader.BaseOfCode;
+
+    for (i = 0; i < nt->FileHeader.NumberOfSections; ++i)
+    {
+        if (memcmp( sec[i].Name, ".text", sizeof(".text" ))) continue;
+        sec[i].Misc.VirtualSize = sec[i].SizeOfRawData = nt->OptionalHeader.SizeOfCode;
+    }
 
     for (i = 0; i < nt->OptionalHeader.NumberOfRvaAndSizes; i++)
         fixup_rva_dwords( &nt->OptionalHeader.DataDirectory[i].VirtualAddress, delta, 1 );
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index deebc9c06e8..af7af0dc7b9 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -600,7 +600,7 @@ void output_module( DLLSPEC *spec )
     int machine = 0;
     unsigned int page_size = get_page_size();
     const char *data_dirs[16] = { NULL };
-    unsigned int nb_sections = 1;
+    unsigned int nb_sections = 2;
 
     /* Reserve some space for the PE header */
 
@@ -715,7 +715,7 @@ void output_module( DLLSPEC *spec )
     output( "\t.long 0\n" );              /* SizeOfUninitializedData */
     output_rva( spec->init_func ?         /* AddressOfEntryPoint */
                 asm_name(spec->init_func) : "0" );
-    output( "\t.long 0\n" );              /* BaseOfCode */
+    output_rva( ".L__wine_spec_text" );   /* BaseOfCode */
     if (get_ptr_size() == 4)
         output_rva( ".L__wine_spec_data" ); /* BaseOfData */
     output( "\t%s .L__wine_spec_dos\n",   /* ImageBase */
@@ -750,6 +750,20 @@ void output_module( DLLSPEC *spec )
 
     output_data_directories( data_dirs );
 
+    /* .text section */
+    output( "\t.ascii \".text\"\n" );                  /* Name */
+    output( "\t.align 8, 0\n" );
+    output( "\t.long 0\n" );                           /* VirtualSize */
+    output_rva( "%s", ".L__wine_spec_text" );          /* VirtualAddress */
+    output( "\t.long 0\n" );                           /* SizeOfRawData */
+    output_rva( "%s", ".L__wine_spec_text" );          /* PointerToRawData */
+    output( "\t.long 0\n" );                           /* PointerToRelocations */
+    output( "\t.long 0\n" );                           /* PointerToLinenumbers */
+    output( "\t.short 0\n" );                          /* NumberOfRelocations */
+    output( "\t.short 0\n" );                          /* NumberOfLinenumbers */
+    output( "\t.long 0x60000020\n"                     /* Characteristics */
+            /* CNT_CODE|MEM_READ|MEM_EXECUTE */ );
+
     /* .data section */
     output( "\t.ascii \".data\"\n" );                  /* Name */
     output( "\t.align 8, 0\n" );
@@ -784,6 +798,10 @@ void output_spec32_file( DLLSPEC *spec )
 
     if (target_platform != PLATFORM_WINDOWS)
     {
+        output( "\t.section .init\n" );
+        output( "\t.align %u\n", page_size );
+        output( "\t.L__wine_spec_text:\n" );
+
         output( "\t%s\n", get_asm_data_section() );
         output( "\t.align %u, 0\n", page_size );
         output( "\t.L__wine_spec_data:\n" );
-- 
2.27.0

>From a3598dca279e5a7c17ae317cb3d247dca4096edf Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Wed, 17 Jun 2020 17:53:28 +0200
Subject: [PATCH 13/32] winebuild: Output relay data to .data section.

---
 tools/winebuild/build.h  |  1 +
 tools/winebuild/spec16.c |  1 +
 tools/winebuild/spec32.c | 58 ++++++++++++++++++++--------------------
 3 files changed, 31 insertions(+), 29 deletions(-)

diff --git a/tools/winebuild/build.h b/tools/winebuild/build.h
index c3a8756e010..b5a45a10968 100644
--- a/tools/winebuild/build.h
+++ b/tools/winebuild/build.h
@@ -300,6 +300,7 @@ extern void read_undef_symbols( DLLSPEC *spec, char **argv );
 extern void resolve_imports( DLLSPEC *spec );
 extern int is_undefined( const char *name );
 extern int has_imports(void);
+extern void output_relay_data( DLLSPEC *spec );
 extern void output_get_pc_thunk(void);
 extern void output_module( DLLSPEC *spec );
 extern void output_stubs( DLLSPEC *spec );
diff --git a/tools/winebuild/spec16.c b/tools/winebuild/spec16.c
index a52c03aaa6a..1c8cf341402 100644
--- a/tools/winebuild/spec16.c
+++ b/tools/winebuild/spec16.c
@@ -824,6 +824,7 @@ void output_spec16_file( DLLSPEC *spec16 )
     output_module16( spec16 );
     output_stubs( spec16 );
     output_exports( spec32 );
+    output_relay_data( spec32 );
     output_imports( spec16 );
     if (!strcmp( spec16->dll_name, "kernel" )) output_asm_relays16();
     if (needs_get_pc_thunk) output_get_pc_thunk();
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index af7af0dc7b9..69c33c79cb9 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -516,36 +516,10 @@ void output_exports( DLLSPEC *spec )
         }
     }
 
-    /* output relays */
-
-    if (needs_relay)
-    {
-        if (target_platform == PLATFORM_WINDOWS)
-        {
-            output( "\t.data\n" );
-            output( "\t.align %d\n", get_alignment(get_ptr_size()) );
-        }
-        else
-        {
-            output( "\t.align %d\n", get_alignment(get_ptr_size()) );
-            output( ".L__wine_spec_exports_end:\n" );
-        }
-
-        output( ".L__wine_spec_relay_descr:\n" );
-        output( "\t%s 0xdeb90002\n", get_asm_ptr_keyword() );  /* magic */
-        output( "\t%s 0\n", get_asm_ptr_keyword() );           /* relay func */
-        output( "\t%s 0\n", get_asm_ptr_keyword() );           /* private data */
-        output( "\t%s __wine_spec_relay_entry_points\n", get_asm_ptr_keyword() );
-        output( "\t%s .L__wine_spec_relay_entry_point_offsets\n", get_asm_ptr_keyword() );
-        output( "\t%s .L__wine_spec_relay_args_string\n", get_asm_ptr_keyword() );
-
-        output_relay_debug( spec );
-    }
-    else if (target_platform != PLATFORM_WINDOWS)
+    if (target_platform != PLATFORM_WINDOWS)
     {
-            output( "\t.align %d\n", get_alignment(get_ptr_size()) );
-            output( ".L__wine_spec_exports_end:\n" );
-            output( "\t%s 0\n", get_asm_ptr_keyword() );
+        output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+        output( ".L__wine_spec_exports_end:\n" );
     }
 
     /* output import thunks */
@@ -590,6 +564,31 @@ void output_exports( DLLSPEC *spec )
 }
 
 
+/*******************************************************************
+ *         output_relay_data
+ *
+ * Output the delay data for a Win32 module.
+ */
+void output_relay_data( DLLSPEC *spec )
+{
+    if (!has_relays( spec )) return;
+
+    /* output relay data */
+
+    output( "\t%s\n", get_asm_data_section() );
+    output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( ".L__wine_spec_relay_descr:\n" );
+    output( "\t%s 0xdeb90002\n", get_asm_ptr_keyword() );  /* magic */
+    output( "\t%s 0\n", get_asm_ptr_keyword() );           /* relay func */
+    output( "\t%s 0\n", get_asm_ptr_keyword() );           /* private data */
+    output( "\t%s __wine_spec_relay_entry_points\n", get_asm_ptr_keyword() );
+    output( "\t%s .L__wine_spec_relay_entry_point_offsets\n", get_asm_ptr_keyword() );
+    output( "\t%s .L__wine_spec_relay_args_string\n", get_asm_ptr_keyword() );
+
+    output_relay_debug( spec );
+}
+
+
 /*******************************************************************
  *         output_module
  *
@@ -810,6 +809,7 @@ void output_spec32_file( DLLSPEC *spec )
     output_stubs( spec );
     output_exports( spec );
     output_imports( spec );
+    output_relay_data( spec );
     if (needs_get_pc_thunk) output_get_pc_thunk();
     output_resources( spec );
 
-- 
2.27.0

>From cfeea8179f376757e28f2ca8b55b1f2ddb9fcf99 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Wed, 17 Jun 2020 17:54:29 +0200
Subject: [PATCH 14/32] winebuild: Output .edata section header.

---
 tools/winebuild/spec32.c | 32 ++++++++++++++++++++++++++------
 1 file changed, 26 insertions(+), 6 deletions(-)

diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 69c33c79cb9..cecb182b9de 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -155,7 +155,7 @@ static void output_data_directories( const char *names[16] )
         if (names[i])
         {
             output_rva( "%s", names[i] );
-            output( "\t.long %s_end - %s\n", names[i], names[i] );
+            output_size( names[i] );
         }
         else output( "\t.long 0,0\n" );
     }
@@ -390,13 +390,14 @@ void output_exports( DLLSPEC *spec )
     int needs_imports = 0;
     int needs_relay = has_relays( spec );
     int nr_exports = spec->base <= spec->limit ? spec->limit - spec->base + 1 : 0;
+    unsigned int page_size = get_page_size();
     const char *name;
 
     if (!nr_exports) return;
 
     output( "\n/* export table */\n\n" );
     output( "\t%s\n", get_asm_export_section() );
-    output( "\t.align %d\n", get_alignment(4) );
+    output( "\t.align %d, 0\n", page_size );
     output( ".L__wine_spec_exports:\n" );
 
     /* export directory header */
@@ -518,8 +519,8 @@ void output_exports( DLLSPEC *spec )
 
     if (target_platform != PLATFORM_WINDOWS)
     {
-        output( "\t.align %d\n", get_alignment(get_ptr_size()) );
         output( ".L__wine_spec_exports_end:\n" );
+        output( "\t.align %d, 0\n", page_size );
     }
 
     /* output import thunks */
@@ -596,11 +597,13 @@ void output_relay_data( DLLSPEC *spec )
  */
 void output_module( DLLSPEC *spec )
 {
-    int machine = 0;
+    int machine = 0, has_exports = (spec->base <= spec->limit ? 1 : 0);
     unsigned int page_size = get_page_size();
     const char *data_dirs[16] = { NULL };
     unsigned int nb_sections = 2;
 
+    if (has_exports) nb_sections++;
+
     /* Reserve some space for the PE header */
 
     switch (target_platform)
@@ -740,7 +743,7 @@ void output_module( DLLSPEC *spec )
     output( "\t.long 0\n" );              /* LoaderFlags */
     output( "\t.long 16\n" );             /* NumberOfRvaAndSizes */
 
-    if (spec->base <= spec->limit)
+    if (has_exports)
         data_dirs[0] = ".L__wine_spec_exports";   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT] */
     if (has_imports())
         data_dirs[1] = ".L__wine_spec_imports";   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT] */
@@ -777,6 +780,23 @@ void output_module( DLLSPEC *spec )
     output( "\t.long 0xc0000040\n"                     /* Characteristics */
             /* CNT_INITIALIZED_DATA|MEM_READ|MEM_WRITE */ );
 
+    if (has_exports)
+    {
+        /* .edata section */
+        output( "\t.ascii \".edata\"\n" );                 /* Name */
+        output( "\t.align 8, 0\n" );
+        output_size( ".L__wine_spec_exports" );            /* VirtualSize */
+        output_rva( "%s", ".L__wine_spec_exports" );       /* VirtualAddress */
+        output_size( ".L__wine_spec_exports" );            /* SizeOfRawData */
+        output_rva( "%s", ".L__wine_spec_exports" );       /* PointerToRawData */
+        output( "\t.long 0\n" );                           /* PointerToRelocations */
+        output( "\t.long 0\n" );                           /* PointerToLinenumbers */
+        output( "\t.short 0\n" );                          /* NumberOfRelocations */
+        output( "\t.short 0\n" );                          /* NumberOfLinenumbers */
+        output( "\t.long 0x40000040\n"                     /* Characteristics */
+                /* CNT_INITIALIZED_DATA|MEM_READ */ );
+    }
+
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
 }
@@ -794,6 +814,7 @@ void output_spec32_file( DLLSPEC *spec )
     open_output_file();
     output_standard_file_header();
     output_module( spec );
+    output_exports( spec );
 
     if (target_platform != PLATFORM_WINDOWS)
     {
@@ -807,7 +828,6 @@ void output_spec32_file( DLLSPEC *spec )
     }
 
     output_stubs( spec );
-    output_exports( spec );
     output_imports( spec );
     output_relay_data( spec );
     if (needs_get_pc_thunk) output_get_pc_thunk();
-- 
2.27.0

>From 530c08b81d3059bc3126eb4fc8b19214e72ad538 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Wed, 17 Jun 2020 17:56:25 +0200
Subject: [PATCH 15/32] winebuild: Output .idata section header.

---
 tools/winebuild/build.h  |  1 +
 tools/winebuild/import.c | 26 ++++++++++++++++++--------
 tools/winebuild/spec32.c | 20 +++++++++++++++++++-
 tools/winebuild/utils.c  | 10 ++++++++++
 4 files changed, 48 insertions(+), 9 deletions(-)

diff --git a/tools/winebuild/build.h b/tools/winebuild/build.h
index b5a45a10968..f7c010c80a1 100644
--- a/tools/winebuild/build.h
+++ b/tools/winebuild/build.h
@@ -287,6 +287,7 @@ extern const char *get_asm_ptr_keyword(void);
 extern const char *get_asm_string_keyword(void);
 extern const char *get_asm_data_section(void);
 extern const char *get_asm_export_section(void);
+extern const char *get_asm_import_section(void);
 extern const char *get_asm_rodata_section(void);
 extern const char *get_asm_rsrc_section(void);
 extern const char *get_asm_string_section(void);
diff --git a/tools/winebuild/import.c b/tools/winebuild/import.c
index 0719025bee9..e210b0a360e 100644
--- a/tools/winebuild/import.c
+++ b/tools/winebuild/import.c
@@ -796,8 +796,8 @@ static void output_immediate_imports(void)
     /* main import header */
 
     output( "\n/* import table */\n" );
-    output( "\n\t.data\n" );
-    output( "\t.align %d\n", get_alignment(4) );
+    output( "\t%s\n", get_asm_import_section() );
+    output( "\t.align %d, 0\n", get_alignment(4) );
     output( ".L__wine_spec_imports:\n" );
 
     /* list of dlls */
@@ -818,7 +818,7 @@ static void output_immediate_imports(void)
     output( "\t.long 0\n" );     /* Name */
     output( "\t.long 0\n" );     /* FirstThunk */
 
-    output( "\n\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( "\n\t.align %d, 0\n", get_alignment(get_ptr_size()) );
     /* output the names twice, once for OriginalFirstThunk and once for FirstThunk */
     for (i = 0; i < 2; i++)
     {
@@ -855,7 +855,7 @@ static void output_immediate_imports(void)
         {
             struct import_func *func = &import->imports[j];
             if (!func->name) continue;
-            output( "\t.align %d\n", get_alignment(2) );
+            output( "\t.align %d, 0\n", get_alignment(2) );
             output( ".L__wine_spec_import_data_%s_%s:\n", import->c_name, func->name );
             output( "\t.short %d\n", func->hint );
             output( "\t%s \"%s\"\n", get_asm_string_keyword(), func->name );
@@ -906,8 +906,8 @@ static void output_delayed_imports( const DLLSPEC *spec )
     if (list_empty( &dll_delayed )) return;
 
     output( "\n/* delayed imports */\n\n" );
-    output( "\t.data\n" );
-    output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( "\t%s\n", get_asm_import_section() );
+    output( "\t.align %d, 0\n", get_alignment(get_ptr_size()) );
     output( "%s\n", asm_globl("__wine_spec_delay_imports") );
 
     /* list of dlls */
@@ -1244,8 +1244,8 @@ static void output_external_link_imports( DLLSPEC *spec )
     }
 
     output( "\n/* external link thunks */\n\n" );
-    output( "\t.data\n" );
-    output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( "\t%s\n", get_asm_import_section() );
+    output( "\t.align %d, 0\n", get_alignment(get_ptr_size()) );
     output( ".L__wine_spec_external_links:\n" );
     for (i = 0; i < ext_link_imports.count; i++)
         output( "\t%s %s\n", get_asm_ptr_keyword(), asm_name(ext_link_imports.str[i]) );
@@ -1394,12 +1394,22 @@ void output_stubs( DLLSPEC *spec )
 /* output the import and delayed import tables of a Win32 module */
 void output_imports( DLLSPEC *spec )
 {
+    unsigned int page_size = get_page_size();
     if (target_platform == PLATFORM_WINDOWS) return;
+
+    output( "\t%s\n", get_asm_import_section() );
+    output( "\t.align %d, 0\n", page_size );
+    output( ".L__wine_spec_idata:\n" );
+
     output_immediate_imports();
     output_delayed_imports( spec );
     output_immediate_import_thunks();
     output_delayed_import_thunks( spec );
     output_external_link_imports( spec );
+
+    output( "\t%s\n", get_asm_import_section() );
+    output( ".L__wine_spec_idata_end:\n" );
+    output( "\t.align %d\n", page_size );
 }
 
 /* create a new asm temp file */
